#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Nov 20 16:05:27 2018

@author: lessig
"""

import numpy as np


def mcMeasurement( f, n) :

    ival = 0.
    for i in range(n) :
        
        theta = np.random.rand() * np.pi / 2.
        phi = np.random.rand() * 2.0 * np.pi
        
        ival += np.cos(theta) * np.sin(theta) * f(theta,phi)
        
    return (np.pi / 2. * np.pi * 2.) * ival / n    

def mcMeasurementUniformH2( f, n) :

    ival = 0.
    for i in range(n) :
        
        theta = np.arccos( np.random.rand())
        phi = np.random.rand() * 2.0 * np.pi
        
        ival += np.cos(theta) * f(theta,phi)
        
    return (np.pi / 2. * np.pi * 2.) * ival / n    

def mcMeasurementCosH2( f, n) :

    ival = 0.
    for i in range(n) :
        
        theta = np.arccos( np.sqrt(np.random.rand()))
        phi = np.random.rand() * 2.0 * np.pi
        
        ival += f(theta,phi) / np.cos( theta)
        
    return ival / n    

