#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Oct 16 14:07:47 2018

@author: lessig
"""

import numpy as np


def midpointS2( f, ntheta, nphi, theta_max = np.pi) :
    
    dtheta = theta_max / ntheta;
    dphi = (2.0 * np.pi) / nphi;
    
    ival = 0.
    for theta in np.linspace( 0.0, theta_max, ntheta) :
        for phi in np.linspace( 0.0, 2.0*np.pi, nphi) :
            
            ival += dtheta * dphi * np.sin(theta) * f(theta,phi)
            
    return ival
            

def midpointMeasurement( f, ntheta, nphi) :
    
    dtheta = (np.pi / 2.0) / ntheta;
    dphi = (2.0 * np.pi) / nphi;
    
    ival = 0.
    for theta in np.linspace( 0.0, (np.pi / 2.0), ntheta) :
        for phi in np.linspace( 0.0, 2.0*np.pi, nphi) :
            
            ival += dtheta * dphi * np.cos(theta) * np.sin(theta) * f(theta,phi)
            
    return ival

