#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Nov 13 17:08:50 2018

@author: lessig
"""

import numpy as np
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D


def s2tor3( t, p) :
    v = np.zeros(3)
    v[0] = np.sin(t) * np.cos(p)
    v[1] = np.sin(t) * np.sin(p)
    v[2] = np.cos(t) 
    return v    


def visualizePointH2( mode = 'uniformH2', n = 1000 ) :

    # generate points

    if mode == 'uniformH2' :
        ts = np.arccos( np.random.rand( n))
    elif mode == 'uniformR2':
        ts = np.random.rand( n) * np.pi / 2.
    elif mode == 'cosH2':
        ts = np.arccos( np.sqrt(np.random.rand( n)))
    else:
        print( 'Mode not supported')
        return
        
    ps = np.random.rand( n) * 2. * np.pi

    # map to hemisphere
    
    scs = np.zeros( (n,3))
    for i in range(n) :
        scs[i] = s2tor3( ts[i], ps[i])

    # plot

    fig = plt.figure( figsize=(10, 7))
    ax = fig.add_subplot(111, projection='3d')
    
    ax.scatter( scs[:,0], scs[:,1], scs[:,2], c='red', marker='+')
    
    
visualizePointH2('cosH2')
